Bug 75152 - cannot compile kernel on redhat 8.0
cannot compile kernel on redhat 8.0
Status: CLOSED NOTABUG
Product: Red Hat Linux
Classification: Retired
Component: gcc (Show other bugs)
8.0
All Linux
medium Severity high
: ---
: ---
Assigned To: Jakub Jelinek
Brian Brock
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2002-10-04 17:06 EDT by Nick Sklavenitis
Modified: 2007-04-18 12:47 EDT (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2003-12-16 19:17:10 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Nick Sklavenitis 2002-10-04 17:06:05 EDT
From Bugzilla Helper:
User-Agent: Mozilla/5.0 (X11; U; Linux i686; en-US; rv:1.1) Gecko/20020924

Description of problem:
Cannot recompile any kernel with redhat 8.0

Version-Release number of selected component (if applicable):


How reproducible:
Always

Steps to Reproduce:
1.compile standard kernel from kernel.org
2.add grsecurity patch to kernel 2.4.19
3.make menuconfig  works ok
3.make dep  works ok
4. make bzImage  fails
	

Actual Results:  make bzImage failed . this also happens when attempting to
recompile the default kernel that ships with redhat8.0

Expected Results:  should have finished without an error as it does on redhat 7.3

Additional info:

/usr/src/linux-2.4.19/include/linux/list.h: In function `__list_add':
/usr/src/linux-2.4.19/include/linux/list.h:45: internal error: Segmentation fault
Please submit a full bug report,
with preprocessed source if appropriate.
See <URL:http://bugzilla.redhat.com/bugzilla/> for instructions.
make[3]: *** [aec62xx.o] Error 1
make[3]: Leaving directory `/usr/src/linux-2.4.19/drivers/ide'
make[2]: *** [first_rule] Error 2
make[2]: Leaving directory `/usr/src/linux-2.4.19/drivers/ide'
make[1]: *** [_subdir_ide] Error 2
make[1]: Leaving directory `/usr/src/linux-2.4.19/drivers'
make: *** [_dir_drivers] Error 2
Comment 1 Jakub Jelinek 2002-10-04 17:25:05 EDT
Is it reproduceable (and always on the same file)?
If yes, please submit preprocessed source and all options used to build that
file.
Comment 2 Nick Sklavenitis 2002-10-04 18:05:48 EDT
Yes it is reproducable. Try the following.

download kernel-2.4.19 from kernel.org and then add the kernel patch for
grsecurity from www.gresecurity.org

After that just configure the kernel parameters using make menconfig after that
make dep and then once you get to make bzImage it will fail. Mind you the same
thing happens when trying to recompile linux-2.4.18-X  where x represents the
default kernel that ships with redhat 8.0. So i would have to say that yes this
is reproducable 100% of the time for me anyways. Also on the irc room #redhat
there are others with similar issues.

I believe this might be more related to gcc-3.2 than the kernel itself but im
not much of a developer and so i would not e able to say exactly.

Also im running a k6 cpu 3dnow 500mhz with 100megs of ram so this might have to
do with the new optimization settings related to gcc-3.2
Comment 3 Jakub Jelinek 2002-10-04 18:10:11 EDT
Ok, so please rerun the gcc command which compiles aec62xx.c with additional
-save-temps option, attach resulting aec62xx.i and write the exact gcc command
line which reproduces it.
Comment 4 Peter van Egdom 2002-10-31 16:47:28 EST
For what it's worth, I have also a situation on my computer with gcc,
which is reproducable like this:

- Install Red Hat 8.0. (do a full install).
- "su -"
- "cd /usr/src/linux-2.4"
- "make clean"
- "make mrproper"
- "make xconfig" --> 'Load configuration from file' and enter :
   "configs/kernel-2.4.18-i686.config" --> 'Save and exit'
- "make dep"
- "make bzImage"

After a while the compile process freaks out with the following statement :

make[2]: Weggaan uit map `/usr/src/linux-2.4.18-14/arch/i386/lib'
make[1]: Weggaan uit map `/usr/src/linux-2.4.18-14/arch/i386/lib'
make[1]: Binnengaan van map `/usr/src/linux-2.4.18-14'
kallsyms pass 1
ld -m elf_i386 -T /usr/src/linux-2.4.18-14/arch/i386/vmlinux.lds -e stext
arch/i386/kernel/head.o arch/i386/kernel/init_task.o init/main.o init/version.o
init/do_mounts.o --start-group arch/i386/kernel/kernel.o arch/i386/mm/mm.o
kernel/kernel.o mm/mm.o fs/fs.o ipc/ipc.o  drivers/char/char.o
drivers/block/block.o drivers/misc/misc.o drivers/net/net.o
drivers/media/media.o drivers/char/drm/drm.o drivers/net/fc/fc.o
drivers/net/appletalk/appletalk.o drivers/net/tokenring/tr.o
drivers/net/wan/wan.o drivers/atm/atm.o drivers/ide/idedriver.o
drivers/cdrom/driver.o drivers/pci/driver.o drivers/net/pcmcia/pcmcia_net.o
drivers/net/wireless/wireless_net.o drivers/pnp/pnp.o drivers/video/video.o
drivers/md/mddev.o drivers/isdn/vmlinux-obj.o drivers/sensors/sensor.o
net/network.o crypto/crypto.o abi/abi.o
/usr/src/linux-2.4.18-14/arch/i386/lib/lib.a /usr/src/linux-2.4.18-14/lib/lib.a
/usr/src/linux-2.4.18-14/arch/i386/lib/lib.a --end-group -o .tmp_vmlinux1
fs/fs.o: In function `mnt_init':
fs/fs.o(.text.init+0xafc): undefined reference to `init_rootfs'
make[1]: *** [kallsyms] Fout 1
make[1]: Weggaan uit map `/usr/src/linux-2.4.18-14'
make: *** [vmlinux] Fout 2

Comment 5 Stephen Walton 2003-03-11 13:12:28 EST
I have seen this too.  I just installed kernel-source-2.4.18-26.8.0.i386.rpm on
two up-to-date RH 8.0 systems, one a single-CPU Dell workstation and the other a
Monarch dual-CPU server.  About the only thing the systems have in common are
SCSI disks (different controllers though) and Athlon CPU's.  Compiling using
configs/kernel-2.4.18-athlon-smp.config produces the errors shown below on both
machines.  Different config files produce different sets of errors, but I've
never been able to compile this kernel on RH 8.0.  This is VERY important to me,
as I absolutely need to run the latest Adaptec SCSI drivers (aic7xxx version
6.2.28 and aic79xx version 1.3.2, from http://people.freebsd.org/~gibbs/linux)
on my dual-CPU systems to keep them stable, and the drivers are only available
as source code or as updates to now-superseded RedHat kernels.

make[1]: Entering directory `/usr/src/linux-2.4.18-26.8.0'
kallsyms pass 1
ld -m elf_i386 -T /usr/src/linux-2.4.18-26.8.0/arch/i386/vmlinux.lds -e stext
arch/i386/kernel/head.o arch/i386/kernel/init_task.o init/main.o init/version.o
init/do_mounts.o --start-group arch/i386/kernel/kernel.o arch/i386/mm/mm.o
kernel/kernel.o mm/mm.o fs/fs.o ipc/ipc.o  drivers/char/char.o
drivers/block/block.o drivers/misc/misc.o drivers/net/net.o
drivers/media/media.o drivers/char/drm/drm.o drivers/net/fc/fc.o
drivers/net/appletalk/appletalk.o drivers/net/tokenring/tr.o
drivers/net/wan/wan.o drivers/atm/atm.o drivers/ide/idedriver.o
drivers/cdrom/driver.o drivers/pci/driver.o drivers/net/pcmcia/pcmcia_net.o
drivers/net/wireless/wireless_net.o drivers/pnp/pnp.o drivers/video/video.o
drivers/md/mddev.o drivers/isdn/vmlinux-obj.o drivers/sensors/sensor.o
net/network.o crypto/crypto.o abi/abi.o
/usr/src/linux-2.4.18-26.8.0/arch/i386/lib/lib.a
/usr/src/linux-2.4.18-26.8.0/lib/lib.a
/usr/src/linux-2.4.18-26.8.0/arch/i386/lib/lib.a --end-group -o .tmp_vmlinux1
fs/fs.o: In function `zisofs_readpage':
fs/fs.o(.text+0x3a127): undefined reference to `zlib_inflateInit_'
fs/fs.o(.text+0x3a22a): undefined reference to `zlib_inflate'
fs/fs.o(.text+0x3a2eb): undefined reference to `zlib_inflateEnd'
fs/fs.o: In function `mnt_init':
fs/fs.o(.text.init+0xb5c): undefined reference to `init_rootfs'
fs/fs.o: In function `zisofs_init':
fs/fs.o(.text.init+0xfe2): undefined reference to `zlib_inflate_workspacesize'
make[1]: *** [kallsyms] Error 1
make[1]: Leaving directory `/usr/src/linux-2.4.18-26.8.0'
make: *** [vmlinux] Error 2
Comment 6 Stephen Walton 2003-03-12 19:47:51 EST
And an apology:  I was able to get it working.  The correct procedure is:  make
mrproper, "cp configs/kernel-2.4.18-whatever.config .config", "make xconfig",
save and exit after making whatever changes you want, and the usual make
commands.  I've now got 2.4.18-26.8.0 kernel modules for the latest aic7xxx and
aic79xx drivers.

Of course, I don't know why this works and the apparently equally valid
procedure above seems not to.
Comment 7 Peter van Egdom 2003-03-13 14:40:47 EST
Hmmm.. "cp configs/kernel-2.4.20-i686.config ./config" to "/usr/src/linux-2.4"
before the usual make commands, also works for me - but, just as Stephen says,
loading the configuration from the 'make xconfig' session doesn't work. Strange.

Note You need to log in before you can comment on or make changes to this bug.